/***************************************************************************//**
* \file DMASDSPI_TX.c
* \version 2.0
*
*  This file provides the source code to the API for the
*  DMASDSPI_TX component.
*
********************************************************************************
* \copyright
* Copyright 2016-2017, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "DMASDSPI_TX.h"

#if defined(__cplusplus)
extern "C" {
#endif

/* Generated code */
const cy_stc_dma_descriptor_config_t DMASDSPI_TX_Descriptor_1_config =
{
    .retrigger       = CY_DMA_RETRIG_IM,
    .interruptType   = CY_DMA_1ELEMENT,
    .triggerOutType  = CY_DMA_1ELEMENT,
    .channelState    = CY_DMA_CHANNEL_DISABLED,
    .triggerInType   = CY_DMA_1ELEMENT,
    .dataSize        = CY_DMA_BYTE,
    .srcTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .dstTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .descriptorType  = CY_DMA_SINGLE_TRANSFER,
    .srcAddress      = NULL,
    .dstAddress      = NULL,
    .srcXincrement   = 1L,
    .dstXincrement   = 1L,
    .xCount          = 1UL,
    .srcYincrement   = 1L,
    .dstYincrement   = 1L,
    .yCount          = 1UL,
    .nextDescriptor  = NULL
};

cy_stc_dma_descriptor_t DMASDSPI_TX_Descriptor_1 =
{
    .ctl = 0UL,
    .src = 0UL,
    .dst = 0UL,
    .xCtl = 0UL,
    .yCtl = 0UL,
    .nextPtr = 0UL
};


/** DMASDSPI_TX_initVar indicates whether the DMASDSPI_TX 
*  component has been initialized. The variable is initialized to 0 
*  and set to 1 the first time DMASDSPI_TX_Start() is called. This allows 
*  the component to restart without reinitialization after the first 
*  call to the DMASDSPI_TX_Start() routine.
*
*  If re-initialization of the component is required, then the 
*  DMASDSPI_TX_Init() function can be called before the 
*  DMASDSPI_TX_Start() or DMASDSPI_TX_ChEnable() function.
*/
uint8 DMASDSPI_TX_initVar = 0u;


/*******************************************************************************
* Function Name: DMASDSPI_TX_Start
****************************************************************************//**
*
* Based on the settings for descriptor in the customizer this function runs the
* DMA_Descriptor_Init() and then initializes the channel using
* DMA_Chnl_Init(). Enables the DMASDSPI_TX block using the DMA_Chnl_Enable().
*  
*******************************************************************************/
void DMASDSPI_TX_Start(void const * srcAddress, void const * dstAddress)
{
    if (0U == DMASDSPI_TX_initVar)
    {
        DMASDSPI_TX_Init();
        DMASDSPI_TX_initVar = 1u;
    }
    
    Cy_DMA_Descriptor_SetSrcAddress(&DMASDSPI_TX_Descriptor_1, srcAddress);
    Cy_DMA_Descriptor_SetDstAddress(&DMASDSPI_TX_Descriptor_1, dstAddress);
    Cy_DMA_Channel_Enable(DMASDSPI_TX_HW, DMASDSPI_TX_DW_CHANNEL);
}


/*******************************************************************************
* Function Name: DMASDSPI_TX_Init
****************************************************************************//**
*
* Based on the settings for the descriptor in the customizer this function runs the
* DMA_Descriptor_Init() and then initializes the channel using
* DMA_Chnl_Init().
*  
*******************************************************************************/
void DMASDSPI_TX_Init(void)
{
    cy_stc_dma_channel_config_t channelConfig;

    /* Init all descriptors */
    (void)Cy_DMA_Descriptor_Init(&DMASDSPI_TX_Descriptor_1, &DMASDSPI_TX_Descriptor_1_config);


    channelConfig.descriptor  = &DMASDSPI_TX_Descriptor_1;
    channelConfig.preemptable = DMASDSPI_TX_PREEMPTABLE;
    channelConfig.priority    = DMASDSPI_TX_PRIORITY;
    channelConfig.enable      = false;
    channelConfig.bufferable  = DMASDSPI_TX_BUFFERABLE;

    (void)Cy_DMA_Channel_Init(DMASDSPI_TX_HW, DMASDSPI_TX_DW_CHANNEL, &channelConfig);

    Cy_DMA_Enable(DMASDSPI_TX_HW);
}


#if defined(__cplusplus)
}
#endif

/* [] END OF FILE */
