/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

volatile unsigned long nmillis = 0; //used for time measurement

void MillisISR()
{
    //Cy_GPIO_Write(debug1_0_PORT, debug1_0_NUM, 1);
    MCWDT_ClearInterrupt(CY_MCWDT_CTR0);
    uint32 mcwdtIsrMask;
    mcwdtIsrMask = Cy_MCWDT_GetInterruptStatus(MCWDT_HW);
    nmillis++;          //used for time measurements
    disk_timerproc();   //MUST attach this to 1kHz interrupt for file system timeouts to work
    //Cy_GPIO_Write(debug1_0_PORT, debug1_0_NUM, 0);
}

// switch SCLK to fast mode.
void SDCARD_FAST()
{
    // 0: 33MHz, 1; 16MHz, 2:11MHz, 3: 8Mhz (@BusClk_CPU=50MHz)
	SD_CLK_SetDivider(2);
}

// switch SCLK to fast mode.
void SDCARD_SLOW()
{
	// notice: SD card must be initialised at max. 400 kHz
    // 35: 360kHz  (@BusClk_CPU=50MHz)
	SD_CLK_SetDivider(35);
}

FRESULT sdInit(FATFS* FileSys)
{
    //Initialise SD card and file system (note: PrintFxn can be NULL)
	SDSPI_Start(SDCARD_SLOW, SDCARD_FAST, NULL);
    //start millisec ISR
	Cy_SysInt_Init(&MillisecISR_cfg, MillisISR);    
    NVIC_EnableIRQ(srss_interrupt_mcwdt_0_IRQn);
    /* Enable the interrupts for MCWDT Counter 0 only. */
    MCWDT_SetInterruptMask(CY_MCWDT_CTR0);
    /* Start MCWDT Counter 0. */
    MCWDT_Init(&MCWDT_config);
    MCWDT_ClearInterrupt(CY_MCWDT_CTR0);
    MCWDT_Enable(CY_MCWDT_CTR0, MCWDT_TWO_LF_CLK_CYCLES_DELAY);
    //CyDelay(5000);
    //initialise FatFS
	DSTATUS err = disk_initialize(0);
    if(err) return err;
    if ((err = f_mount(FileSys, "/", 1)) != FR_OK) return err;

    SDSPI_SetDMAMode(1);

    return err;
}

/* [] END OF FILE */
